From e405dc01d44923d3f9e693f90ff4f1cd3b1698b6 Mon Sep 17 00:00:00 2001
From: David Carlos <ddavidcarlos1392@gmail.com>
Date: Mar 16 2018 02:30:30 +0000
Subject: [PATCH 15/17] Rename Package model to Project.


  - Kiskadee monitors repositories like github, gitlab, bitbucket, but
  also can monitors linux distributions as Debian. It's better to call
  the source code as Project, instead of Package, because not always we
  will be dealing with packages, but we will always dealing with
  projects.

---

diff --git a/kiskadee/api/app.py b/kiskadee/api/app.py
index 9eb7b3a..eae5017 100644
--- a/kiskadee/api/app.py
+++ b/kiskadee/api/app.py
@@ -4,8 +4,8 @@ from flask import request
 from flask_cors import CORS
 
 from kiskadee.database import Database
-from kiskadee.model import Package, Fetcher, Version, Analysis
-from kiskadee.api.serializers import PackageSchema, FetcherSchema,\
+from kiskadee.model import Project, Fetcher, Version, Analysis
+from kiskadee.api.serializers import ProjectSchema, FetcherSchema,\
         AnalysisSchema
 import json
 from sqlalchemy.orm import eagerload
@@ -30,8 +30,8 @@ def index():
 def packages():
     """Get the list of analyzed packages."""
     if request.method == 'GET':
-        packages = db.session.query(Package).all()
-        package_schema = PackageSchema(
+        packages = db.session.query(Project).all()
+        package_schema = ProjectSchema(
             many=True,
             exclude=['versions.analysis', 'versions.package_id']
         )
@@ -44,7 +44,7 @@ def package_analysis_overview(pkg_name, version):
     """Get a analysis list of some package version."""
 
     #TODO: This can be a simple inner join between package, version and analysis
-    _package_id = db.filter_by_name(Package, pkg_name).id
+    _package_id = db.filter_by_name(Project, pkg_name).id
     version_id = db.session.query(Version)\
             .filter_by(number = version, package_id = _package_id ).first().id
     analysis = (
diff --git a/kiskadee/api/serializers.py b/kiskadee/api/serializers.py
index e7168e9..b6d027c 100644
--- a/kiskadee/api/serializers.py
+++ b/kiskadee/api/serializers.py
@@ -1,7 +1,7 @@
 """Provide objects to serialize the kiskadee models."""
 
 from marshmallow import Schema, fields
-from kiskadee.model import Package, Fetcher, Analysis, Version,\
+from kiskadee.model import Project, Fetcher, Analysis, Version,\
         Report, Analyzer
 
 
@@ -49,7 +49,7 @@ class AnalysisSchema(Schema):
 
 
 class VersionSchema(Schema):
-    """Provide a serializer to the Package model."""
+    """Provide a serializer to the Project model."""
 
     id = fields.Int()
     number = fields.Str()
@@ -57,7 +57,7 @@ class VersionSchema(Schema):
     analysis = fields.Nested(AnalysisSchema, many=True)
 
     def make_object(self, data):
-        """Serialize a Package object."""
+        """Serialize a Project object."""
         print('MAKING OBJECT FROM', data)
         return Version(**data)
 
@@ -76,8 +76,8 @@ class FetcherSchema(Schema):
         return Fetcher(**data)
 
 
-class PackageSchema(Schema):
-    """Provide a serializer to the Package model."""
+class ProjectSchema(Schema):
+    """Provide a serializer to the Project model."""
 
     id = fields.Int()
     name = fields.Str()
@@ -85,6 +85,6 @@ class PackageSchema(Schema):
     versions = fields.Nested(VersionSchema, many=True)
 
     def make_object(self, data):
-        """Serialize a Package object."""
+        """Serialize a Project object."""
         print('MAKING OBJECT FROM', data)
-        return Package(**data)
+        return Project(**data)
diff --git a/kiskadee/database.py b/kiskadee/database.py
index 96cefe4..2c7edf5 100644
--- a/kiskadee/database.py
+++ b/kiskadee/database.py
@@ -4,7 +4,7 @@ from sqlalchemy import create_engine, orm
 
 import kiskadee
 from kiskadee.model import Base
-from kiskadee.model import Package, Fetcher, Version, Report, Analysis
+from kiskadee.model import Project, Fetcher, Version, Report, Analysis
 
 class Database:
     """kiskadee Database class."""
diff --git a/kiskadee/fetchers/debian.py b/kiskadee/fetchers/debian.py
index 1cd1604..9f66aa2 100644
--- a/kiskadee/fetchers/debian.py
+++ b/kiskadee/fetchers/debian.py
@@ -1,4 +1,4 @@
-"""Fetcher to monitor Debian Project Packages."""
+"""Fetcher to monitor Debian Packages."""
 
 import os
 import tempfile
@@ -16,14 +16,14 @@ RUNNING = True
 
 
 class Fetcher(kiskadee.fetchers.Fetcher):
-    """Fetcher to monitor Debian Project Packages."""
+    """Fetcher to monitor Debian Packages."""
 
     def watch(self):
         """Start the monitoring process for Debian Repositories.
 
-        Each project monitored by the fetcher will be
+        Each package monitored by the fetcher will be
         queued by calling the watch parent method,
-        passing the project data as argument.
+        passing it as argument.
         """
         kiskadee.logger.debug("Starting Debian fetcher")
         while RUNNING:
@@ -74,10 +74,10 @@ class Fetcher(kiskadee.fetchers.Fetcher):
         sources = os.path.join(path, 'Sources')
         with open(sources) as sources_file:
             for src in Sources.iter_paragraphs(sources_file):
-                project = self.project_to_enqueue(src)
-                super().watch(**project)
+                package = self.package_to_enqueue(src)
+                super().watch(**package)
 
-    def project_to_enqueue(self, src):
+    def package_to_enqueue(self, src):
         return {'name': src["Package"],
                 'version': self._parse_version(src["Version"]),
                 'fetcher': __name__,
diff --git a/kiskadee/model.py b/kiskadee/model.py
index acbd5a0..83302b9 100644
--- a/kiskadee/model.py
+++ b/kiskadee/model.py
@@ -11,21 +11,21 @@ from kiskadee.report import CppcheckReport, FlawfinderReport
 Base = declarative_base()
 
 
-class Package(Base):
-    """Software packages abstraction.
+class Project(Base):
+    """Software projects abstraction.
 
-    A software package is the source code for a software project. It may be
+    A project is the source code stored on some repository. It may be
     upstream's distribution or the sources provided by some other source, like
     a linux distribution.
     """
 
-    __tablename__ = 'packages'
+    __tablename__ = 'projects'
     id = Column(Integer,
-                Sequence('packages_id_seq', optional=True), primary_key=True)
+                Sequence('projects_id_seq', optional=True), primary_key=True)
     name = Column(Unicode(255), nullable=False)
     homepage = Column(Unicode(255), nullable=True)
     fetcher_id = Column(Integer, ForeignKey('fetchers.id'), nullable=False)
-    versions = orm.relationship('Version', backref='packages')
+    versions = orm.relationship('Version', backref='projects')
     __table_args__ = (
             UniqueConstraint('name', 'fetcher_id'),
             )
@@ -36,18 +36,18 @@ class Package(Base):
         if ('meta' in data) and ('homepage' in data['meta']):
             homepage = data['meta']['homepage']
 
-        _package = Package(
+        _project = Project(
                 name=data['name'],
                 homepage=homepage,
                 fetcher_id=data['fetcher_id']
                 )
-        db.session.add(_package)
+        db.session.add(_project)
         db.session.commit()
         _version = Version(number=data['version'],
-                           package_id=_package.id)
+                           project_id=_project.id)
         db.session.add(_version)
         db.session.commit()
-        return _package
+        return _project
 
     @staticmethod
     def update(db, project, data):
@@ -81,20 +81,20 @@ class Fetcher(Base):
     name = Column(Unicode(255), nullable=False, unique=True)
     target = Column(Unicode(255), nullable=True)
     description = Column(UnicodeText)
-    packages = orm.relationship('Package', backref='fetchers')
+    projects = orm.relationship('Project', backref='fetchers')
 
 
 class Version(Base):
-    """Abstraction of a package version."""
+    """Abstraction of a project version."""
 
     __tablename__ = 'versions'
     id = Column(Integer,
                 Sequence('versions_id_seq', optional=True), primary_key=True)
     number = Column(Unicode(100), nullable=False)
-    package_id = Column(Integer, ForeignKey('packages.id'), nullable=False)
+    project_id = Column(Integer, ForeignKey('projects.id'), nullable=False)
     analysis = orm.relationship('Analysis', backref='versions')
     __table_args__ = (
-            UniqueConstraint('number', 'package_id'),
+            UniqueConstraint('number', 'project_id'),
             )
 
 
@@ -127,7 +127,7 @@ class Analyzer(Base):
         db.session.commit()
 
 class Analysis(Base):
-    """Abstraction of a package analysis."""
+    """Abstraction of a project analysis."""
 
     __tablename__ = 'analysis'
     id = Column(Integer,
@@ -155,7 +155,7 @@ class Analysis(Base):
                 }
             Report.save(db, dict_analysis, data, _analyzer.name)
             kiskadee.logger.debug(
-                    "MONITOR: Saved analysis done by {} for package: {}-{}"
+                    "MONITOR: Saved analysis done by {} for project: {}-{}"
                     .format(analyzer, data["name"], data["version"])
                 )
             return
@@ -197,7 +197,7 @@ class Report(Base):
             db.session.add(_reports)
             db.session.commit()
             kiskadee.logger.debug(
-                    "MONITOR: Saved analysis reports for {} package"
+                    "MONITOR: Saved analysis reports for {} project"
                     .format(data["name"])
                 )
         except KeyError as key:
@@ -208,7 +208,7 @@ class Report(Base):
                 )
         except Exception as err:
             kiskadee.logger.debug(
-                    "MONITOR: Failed to get analysis reports to {} package"
+                    "MONITOR: Failed to get analysis reports to {} project"
                     .format(data["name"])
                 )
             kiskadee.logger.debug(err)
diff --git a/kiskadee/monitor.py b/kiskadee/monitor.py
index 58f1493..d88a085 100644
--- a/kiskadee/monitor.py
+++ b/kiskadee/monitor.py
@@ -9,7 +9,7 @@ import os
 import importlib
 
 import kiskadee
-from kiskadee.model import Package, Fetcher, Version, Report, Analysis, Analyzer
+from kiskadee.model import Project, Fetcher, Version, Report, Analysis, Analyzer
 
 RUNNING = True
 
@@ -56,7 +56,7 @@ class Monitor:
         fetcher_name = data['fetcher'].split('.')[-1]
         project_name = data['name']
         fetcher = self.db.filter_by_name(Fetcher, fetcher_name)
-        project = self.db.filter_by_name(Package, project_name)
+        project = self.db.filter_by_name(Project, project_name)
         return fetcher, project
 
     def is_a_new_project_version(self, project, data):
@@ -71,11 +71,11 @@ class Monitor:
     def save_analyzed_project(self, data):
         if not data:
             return {}
-        project = self.db.filter_by_name(Package, data['name'])
+        project = self.db.filter_by_name(Project, data['name'])
         if not project:
-            project = Package.save(self.db, data)
+            project = Project.save(self.db, data)
         if project:
-            project = Package.update(self.db, project, data)
+            project = Project.update(self.db, project, data)
 
         for analyzer, result in data['results'].items():
             Analysis.save(self.db, data, analyzer, result, project.versions[-1])
diff --git a/kiskadee/tests/api/test_api.py b/kiskadee/tests/api/test_api.py
index cff7f1b..919ae5f 100644
--- a/kiskadee/tests/api/test_api.py
+++ b/kiskadee/tests/api/test_api.py
@@ -37,7 +37,7 @@ class ApiTestCase(unittest.TestCase):
                 )
 
         self.db.filter_by_name = MagicMock()
-        self.db.session.query(kiskadee.model.Package)\
+        self.db.session.query(kiskadee.model.Project)\
             .filter_by().id = MagicMock()
         self.db.session.query(kiskadee.model.Version)\
             .filter_by().id = MagicMock()
diff --git a/kiskadee/tests/integration/test_monitor.py b/kiskadee/tests/integration/test_monitor.py
index 9691ca2..f4acf72 100644
--- a/kiskadee/tests/integration/test_monitor.py
+++ b/kiskadee/tests/integration/test_monitor.py
@@ -3,7 +3,7 @@ from unittest.mock import MagicMock
 
 from kiskadee.monitor import Monitor
 from kiskadee.queue import Queues
-from kiskadee.model import Package, Fetcher
+from kiskadee.model import Project, Fetcher
 import kiskadee.queue
 import kiskadee.fetchers.debian
 import kiskadee.fetchers.anitya
@@ -14,7 +14,7 @@ class MonitorTestCase(unittest.TestCase):
 
     def setUp(self):
         def mocked_models(klass):
-            class Package:
+            class Project:
                 def all(self):
                     [self.pkg1, self.pkg2, self.pkg3, self.pkg4]
             klass()
@@ -57,7 +57,7 @@ class MonitorTestCase(unittest.TestCase):
 
     def test_send_project_to_runner(self):
         fetcher = Fetcher(name='example')
-        Package(name='project1', fetcher_id=fetcher.id)
+        Project(name='project1', fetcher_id=fetcher.id)
         self.monitor.get_fetcher_and_project = MagicMock(
                 return_value=[fetcher, {}]
                 )
diff --git a/kiskadee/tests/units/test_model.py b/kiskadee/tests/units/test_model.py
index f542aaa..b0aafa7 100644
--- a/kiskadee/tests/units/test_model.py
+++ b/kiskadee/tests/units/test_model.py
@@ -14,7 +14,7 @@ class ModelTestCase(unittest.TestCase):
 
     def setUp(self):
         kiskadee.tests.clean_test_db(self.db, model.Base.metadata)
-        self.package = model.Package(name='python-kiskadee')
+        self.package = model.Project(name='python-kiskadee')
         self.version = model.Version(number='1.0-rc1')
         self.fetcher = model.Fetcher(
               name='kiskadee-fetcher', target='university'
@@ -44,7 +44,7 @@ class ModelTestCase(unittest.TestCase):
         self.assertEqual(fetchers, [self.fetcher])
 
     def test_query_package(self):
-        packages = self.db.session.query(model.Package).all()
+        packages = self.db.session.query(model.Project).all()
         self.assertEqual(packages, [self.package])
 
     def test_query_version(self):
@@ -76,14 +76,14 @@ class ModelTestCase(unittest.TestCase):
             self.db.session.commit()
 
     def test_add_package_without_fetcher(self):
-        package = model.Package(name='foo-bar')
+        package = model.Project(name='foo-bar')
         self.db.session.add(package)
         with self.assertRaises(exc.IntegrityError):
             self.db.session.commit()
 
     def test_unique_package_in_fetcher(self):
-        package_1 = model.Package(name='foo-bar')
-        package_2 = model.Package(name='foo-bar')
+        package_1 = model.Project(name='foo-bar')
+        package_2 = model.Project(name='foo-bar')
         self.fetcher.packages.append(package_1)
         self.fetcher.packages.append(package_2)
         with self.assertRaises(exc.IntegrityError):
@@ -100,7 +100,7 @@ class ModelTestCase(unittest.TestCase):
     def test_compose_kiskadee_source(self):
         _analyzer = self.db.session.query(model.Analyzer)\
                     .filter(model.Analyzer.name == "cppcheck").first()
-        package = model.Package(
+        package = model.Project(
                 name='bla',
                 fetcher_id=self.fetcher.id
                 )
@@ -132,7 +132,7 @@ class ModelTestCase(unittest.TestCase):
                 .filter(model.Analyzer.name == "flawfinder").first()
                 )
 
-        package = model.Package(
+        package = model.Project(
                 name='bla',
                 fetcher_id=self.fetcher.id
                 )
@@ -164,8 +164,8 @@ class ModelTestCase(unittest.TestCase):
         self.db.session.commit()
 
         saved_package = (
-                self.db.session.query(model.Package)
-                .filter(model.Package.name == 'bla').first()
+                self.db.session.query(model.Project)
+                .filter(model.Project.name == 'bla').first()
                 )
         analysis = saved_package.versions[-1].analysis
         self.assertEqual(len(analysis), 2)

